##############################################################################
#
#  			Copyright 2003 MPIMG Berlin, Germany.
#			      All Rights Reserved
#
#
#  System        : 
#  Module        : 
#  Object Name   : $RCSfile$
#  Revision      : $Revision$
#  Date          : $Date$
#  Author        : $Author$
#  Created By    : Dr. Detlef Groth
#  Created       : Mon Mar 10 16:41:10 2003
#  Last Modified : <031126.1422>
#
#  Description	
#
#  Notes
#
#  History
#	
#  $Log$
#
##############################################################################
#
#  Copyright (c) 2003 MPIMG Berlin, Germany.
# 
#  All Rights Reserved.
# 
#  This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
#  reproduced,  translated,  or  reduced to any  electronic  medium or machine
#  readable form without prior written consent from MPIMG Berlin, Germany.
#
##############################################################################

package provide app-dgTclODBC 1.0
package require Tk
package require BWidget
package require iniparse
package require Wikit
package require starkit
package require tablelist
package require tclodbc 
package require ctext
namespace import tablelist::tablelist
set dir [file dirname [info script]] 
source [file join $dir iniload.tcl]
source [file join $dir dgutils.tcl]
catch {
    package require dde
    dde servername dgTclODBC
}
global var
global gui
global data
global mnu
set var(lastdir) $dir
set var(version) 0.1
set var(debug) 1
set var(exportfile) "temp.tab"
set var(resfile) [file rootname $argv0].res
set var(stop) 0
set var(types) {
        {"SQL Files"   ".sql" }
        {"All Files"        * }
    }
set var(serverfile) "temp.sql"    
    

proc main {} {
    global gui var img data mnu
    set var(appname) [file rootname [file tail [info script]]]
    wm title . "$var(appname) $var(version) "
    menu .menubar
    . config -menu .menubar
    set mnu(file) [menu .menubar.file -tearoff 0]
    .menubar add cascade -label File -underline 0 -menu $mnu(file) 
    set mnu(help) [menu .menubar.help -tearoff 0]
    .menubar add cascade -label Help -underline 0 -menu $mnu(help) 
    $mnu(help) add command -label "About ... " -underline 0 -command \
             { tk_messageBox -title "About!" -icon info \
              -message "$var(appname) by Dr. Detlef Groth\n\n     2003\n\n   detlef@dgroth.de" -type ok}
    
    $mnu(help) add command -label "Help" -underline 0 -command {help 0}
    
  

  
    $mnu(file) add command -label "Refresh Databases" -underline 0 -command {
        $gui(lb) delete 0 end
        foreach db [database datasources] {
            $gui(lb) insert end [lindex $db 0]
        }
    }
   
#    $mnu(file) add command -label "Database Server" -underline 0 -command {
#        set var(databasefile) [file mtime "$var(serverfile)"]
#        while (1) {
#            sleep 3000
#            if {[file mtime "$var(serverfile)"] > $var(databasefile)} {
#                tk_messageBox -title "Info!" -icon info -message "$var(serverfile) was modified!" -type ok
#                set var(databasefile) [file mtime "$var(serverfile)"]
#                Database:Server
#            }
#            update 
#            update idletasks
#        }
       
#    }
       
    #$mnu(file) add command -label "Open File ..." -underline 0 -command File:Open
    #$mnu(file) add separator
    set mnu(file-recent) [menu .menubar.file.recent -tearoff 0]
    #.menubar.file add cascade -label "Recent Files ..." -underline 0 -menu $mnu(file-recent) 
    ini_load RECENTS 10 LASTFILE 1
    ini_mnu_install $mnu(file-recent) RECENTS File:Load 9
  
    ini_mnu_update  $mnu(file-recent) RECENTS File:Load 9
    $mnu(file) add separator
    $mnu(file) add command -label Exit -underline 1 -command  {ini_write ; destroy .}
    if { [ini_option_get LASTFILE ] ne "" } {
        set var(lastfile) [ini_option_get LASTFILE]
        set var(lastdir) [file dirname $var(lastfile)]
    } 
    set widgets [Paned .pan vertical frame frame tablelist]
    set gui(table) [lindex $widgets 3]
    append var(gui) "$gui(table) "
    set f1 [lindex $widgets 1]
    set f2 [lindex $widgets 2]
    set widgets [Paned $f1.pan horizontal listbox Tree tablelist]
    set gui(lb) [lindex $widgets 1]
    set gui(tree) [lindex $widgets 2] 
    append var(gui) "$gui(lb) "
    set gui(tables) [lindex $widgets 3]
    append var(gui) "$gui(tables) "
    $gui(tables) configure -columns {0 "table" 0 "columns"} -stretch all
   
    
    foreach db [database datasources] {
        $gui(lb) insert end [lindex $db 0]
    }
    bind $gui(lb) <Double-1> {
        set index [$gui(lb) curselection]
        set sel [$gui(lb) get $index]
        DataBase:Tables $sel
    }
    bind [$gui(tables) bodypath] <Double-1> { 
        set index [Tablelist:GetRow $gui(tables) [expr {%x + [winfo x %W]}] [expr {%y + [winfo y %W]}]]
        set tab [$gui(tables) cellcget [lindex [split $index ,] 0],0 -text]
#        set cols [$gui(tables) cellcget [lindex [split $index ,] 0],1 -text]
        #tk_messageBox -title "Info!" -icon info -message "View: $view" -type ok
        set var(lasttab) $tab
        regsub -all { } $tab "" tab
        Tablelist:Colconf $gui(table) $var(tab-cols-$tab)
        $gui(sqledit) delete 1.0 end
        if [regexp " " $var(lasttab)] {
            $gui(sqledit) insert end "select * from '$var(lasttab)'"
            SQL:Statement $var(lastdb) "select * from '$var(lasttab)'" $var(tab-cols-$tab) table
        } else {
            $gui(sqledit) insert end "select * from $var(lasttab)"
            SQL:Statement $var(lastdb) "select * from $var(lasttab)" $var(tab-cols-$tab) table
       
        }
        Menu:Table
    }
    pack [labelframe $f2.f -text "SQL Editor:"] -side top -expand yes -fill both  
    append var(gui) "$f2.f "
    pack [frame $f2.f.f] -side left -expand no -fill both
    set l [label $f2.f.f.lbl -text max:]
    set sb [spinbox $f2.f.f.sb -width 8 -from 100 -to 10000 -increment 100 -textvariable var(max)]
    grid $l $sb
    set l [label $f2.f.f.lbl2 -text offset:]
    set sb [spinbox $f2.f.f.sb2 -width 8 -from 0 -to 100000 -increment 100 -textvariable var(offset)]
    grid $l $sb
    set var(nprogress) 0
    set l [label $f2.f.f.lblpb -textvariable var(nprogress)]
    set pb [ProgressBar $f2.f.f.pb -maximum 100 -variable var(progress)]
    grid $l $pb -pady 5 -padx 10
    grid [labelframe $f2.f.f.f -text "Statement Execution: " ] -columnspan 2 -padx 10 -pady 10
    pack [button $f2.f.f.f.btn -text " Into Table" -command {SQL:TextGet $gui(sqledit) table}] -side left -pady 5 -padx 5 -fill x
    pack [button $f2.f.f.f.stop -text " Stop " -command { set var(stop) 1 }] -side left -pady 5 -padx 5 -fill x
    #    pack [button $f2.f.f.f.btnf -text " Into Server" -command Database:Client]  -pady 5 -padx 5 -side left -fill x
    pack [button $f2.f.f.f.btns -text " Into File" -command {SQL:TextGet $gui(sqledit) file}]  -pady 5 -padx 5 -side left -fill x
    grid [labelframe $f2.f.f.f2 -text "Statement Storage: "] -columnspan 2 -padx 10 -pady 10
    pack [button $f2.f.f.f2.btnOpen -text "  Open SQL  " -command {Editor:FileLoad $gui(sqledit) $var(types)}] -side left -pady 5 -padx 5 -fill x
    pack [button $f2.f.f.f2.btnSave -text "  Save SQL  " -command { Editor:FileSave $gui(sqledit) $var(types)} ] -side left -pady 5 -padx 5 -fill x
    
    set f [frame $f2.f.sqlf] 
    pack $f -expand yes -fill both
    pack [ComboBox $f.combo -editable false -modifycmd {
          $gui(sqledit) delete 1.0 end
          $gui(sqledit) insert end [$gui(cb) cget -text]
        }  ] -side top -expand yes -fill x
    set gui(cb) $f.combo
    set gui(sqledit) [Scrolled $f.sql ctext]
    append var(gui) $gui(sqledit)
    Ctext:Hilight $gui(sqledit)
    bind $gui(sqledit) <Control-Return> {SQL:TextGet $gui(sqledit)}
    bind Text <ButtonPress-3> {
        if { [winfo exists .tmenu] } {
            set x [winfo pointerx .]
            
            set y [winfo pointery .]
            tk_popup .tmenu $x $y 
        }
    }
    #if [info exists var(lastfile)] {
    #    File:Load $var(lastfile)
    #}
        
    
}

proc DataBase:Tables {dbase} {
    global gui var dir
    database connect db $dbase
    set var(lastdb) $dbase
    $gui(tables) delete 0 end
    $gui(tree) delete [$gui(tree) nodes root]
    set x 0
    set tables {}
     set tabn 0
     set tabm 0
    foreach  tab [db tables] {
        incr x
       
        if {[lindex $tab 3] eq "SYSTEM TABLE"} {
            continue
        }
        set tabelle [lindex $tab 2]
        set cols {}
       
        if {![string match {*$} $tabelle]} {
            lappend tables $tabelle
            incr tabn
            set col [db columns $tabelle]
            if {[lindex $tab 3] eq "TABLE"} {
                #tk_messageBox -title "Info!" -icon info -message "$dir(../../images/tables.gif" -type ok
                $gui(tree) insert end root tabn$tabn -text "$tabelle" -image  [image create photo -file "$dir/../../images/tables.gif"]
            } elseif {[lindex $tab 3] eq "VIEW"} {
                $gui(tree) insert end root tabn$tabn -text "$tabelle" -image  [image create photo -file "$dir/../../images/view.gif"]
            }
            foreach c $col {
                incr tabm
                set co "[lindex $c 3]"
                set type "[lindex $c 5]"
                set len "[lindex $c 6]"
                $gui(tree) insert end tabn$tabn tabm$tabm -text "$co $type $len" -image  [image create photo -file "$dir/../../images/field.gif"]
       
                append cols "$co "
            }
           $gui(tables) insert end test
            $gui(tables) cellconfigure end,0 -text $tabelle
            
            $gui(tables) cellconfigure end,1 -text $cols
            regsub -all { } $tabelle "" tabelle
            set var(tab-cols-$tabelle) [split [string trim $cols]] 
        }
        set cols {}
    }
    db disconnect
    return $tables
    
}
proc SQL:TextGet {w kind} {
    global gui var
    set sql [$w get 1.0 end]
    regsub -all -- {--.+?\n} $sql " " sql
    regsub -all {[ \n]+} $sql " " sql
 
    if {[regexp -nocase {^\s*select +(.+) +from +'?([^ ]+?)'?} $sql matchvar columns table]} {
        if {$columns ne "*"} {
            regsub -all {[^ ]+ as +} $columns "" columns
            regsub -all " " $columns "" columns
            regsub -all "'" $columns "" columns
            set cols [split $columns ","]
        }  else {
            regsub -all " " $table "" table
            regsub -all {["']} $table "" table ;#"
            set cols $var(tab-cols-$table)
        }
        set answer [tk_messageBox -title "Question!" -message "Executing `$sql` ?" -type yesno -icon question]
        if { $answer } {
            if {$kind eq "table"} {
                Tablelist:Colconf $gui(table) $cols
            }
            SQL:Statement $var(lastdb) $sql $cols  $kind
        } 
      
    } else {
        SQL:Statement $var(lastdb) $sql null  null
    }
        
}
proc Debug {msg} {
    global var
    if {$var(debug) == 0} {
        return
    } elseif {$var(debug) == 1} {
        tk_messageBox -title "Debug Info!" -icon info -message " $msg" -type ok
    } else {
        puts $msg
    }
}

proc SQL:Statement {dbase statement cols kind} {
    global gui var
 
    if {![regexp {^\s*select} $statement]} {
        if [regexp -nocase {[a-z][a-z]} $statement] {
            set answer [tk_messageBox -title "Question!" -message "Really execute $statement ?" -type yesno -icon question]
            if { $answer } {
                database connect db $dbase
                db statement s $statement
                s 
                db disconnect
                return
            }
        }
      
    }
    # so it is a select statement
    if {$kind eq "file"} {
        set types {
            {{Tab Files}       {.tab}        }
            {{All Files}        *             }
        }
        set savefile [tk_getSaveFile -filetypes $types -initialfile $var(exportfile)]
        if {$savefile eq ""} {
            return
            
        } else {
            set var(exportfile) $savefile
            set out [open $savefile w 0600]
            puts $out [join $cols "\t"]
        }
    } else {
        $gui(table) delete 0 end
    }
    #busy [split $var(gui)]
  
   
    database connect db $dbase
    db statement s $statement
    s execute
    set newvals {}
    ComboBox:History:Add $gui(cb) $statement
 
    set n 1
    #Debug "max $max offset $offset"
    set max $var(max)
    incr max $var(offset)
    set offset $var(offset)
    while {[s fetch row]} {
        if {$kind ne "file"} {
            if {[expr $n % 20] == 0} {
                set var(progress) [expr $n * 100 / $max]
                set sl [string length $var(progress)]
                switch -exact -- $sl {
                    1 { set var(nprogress) "  $var(progress)%" }
                    2 { set var(nprogress) " $var(progress)%" }
                    3 { set var(nprogress) "$var(progress)%" }
                }
            }
            if {[expr $n % 100] == 0} {
                update
                update idletasks
                if {$var(stop) == 1} {
                    set var(stop) 0
                    catch  {db disconnect}
                    tk_messageBox -title "Info!" -icon info -message "Operation was canceled after $n items" -type ok
                    return
                }
                
            }
            if {$n > $max} {
                return
            } elseif {$n <= $offset} {
                incr n
                continue
            }
            $gui(table) insert end test
            $gui(table) cellconfigure end,0 -text $n
            set y 1
            foreach c $cols {
                set text $row($c)
                if {$text eq ""} {
                    set text NULL
                }
                $gui(table) cellconfigure end,$y -text $text
                incr y
            }
            incr n
        } else {
            set y 1
            foreach c $cols {
                set text $row($c)
                if {$text eq ""} {
                    set text NULL
                }
                puts -nonewline $out "$text"
                if {$y < [llength $cols]} {
                    puts -nonewline $out "\t"
                }
                incr y

            }
            puts $out ""
        }
    }
    db disconnect
    if {$kind eq "file"} {
        close $out
        tk_messageBox -title "Info!" -icon info -message "$savefile was saved!" -type ok
    }
    #unbusy [split $var(gui)]
        
}
proc SQL:StatementGUI {n max offset} {
    global var gui
    if {[expr $n % 20] == 0} {
        set var(progress) [expr $n * 100 / $max]
        set sl [string length $var(progress)]
        switch -exact -- $sl {
            1 { set var(nprogress) "  $var(progress)%" }
            2 { set var(nprogress) " $var(progress)%" }
            3 { set var(nprogress) "$var(progress)%" }
        }
    }
    if {[expr $n % 100] == 0} {
        update
        update idletasks
        if {$var(stop) == 1} {
            set var(stop) 0
            catch  {db disconnect}
            tk_messageBox -title "Info!" -icon info -message "Operation was canceled after $n items" -type ok
            return
        }
        
    }
    if {$n > $max} {
        return
    } elseif {$n <= $offset} {
        incr n
        continue
    }
    $gui(table) insert end test
    $gui(table) cellconfigure end,0 -text $n
  
    
}

proc Ctext:Hilight {win} {
    ctext::enableComments $win ;#darkgreen
    ctext::addHighlightClassForSpecialChars $win brackets darkgreen {[]{}()}
    ctext::addHighlightClass $win control blue [list SET ON CONFLICT ROLLBACK ABORT FAIL IGNORE REPLACE DISTINCT SELECT WHERE FROM LIKE GLOB UPDATE DROP TABLE ORDER BY CREATE VIEW AS ISNULL NOTTNULL IN INSERT INTO CASE WHEN THEN ELSE END BETWEEN TRIGGER INDEX]
    ctext::addHighlightClass $win control blue [list set on conflict rollback abort fail ignore replace distinct select where from like glob update drop table order by create view as isnull notnull in insert into case when then else end between trigger index]
    ctext::addHighlightClass $win types blue [list and AND not NOT OR or]
    ctext::addHighlightClassForRegexp $win comment darkgreen {--[^\n]*}
    #ctext::addHighlightClassForRegexp $win comment2 darkgreen {//[.\n]+ll}
    #ctext::addHighlightClassForRegexp $win comment darkgreen {/\\*.+\\*/}
    ctext::addHighlightClassForRegexp $win quotes magenta {["'].+?['"]}
    ctext::addHighlightClassForSpecialChars $win math red [list =!<>]
}
proc Menu:Table {} {
    global var gui
    set tables [DataBase:Tables $var(lastdb)]
    if {[winfo exists .tmenu]} {destroy .tmenu}
    menu .tmenu -tearoff 0
    .tmenu add command -label "Cut" -underline 2 -command "tk_textCut $gui(sqledit)" -accelerator Ctrl+x
    .tmenu add command -label "Copy" -underline 0 -command "tk_textCopy $gui(sqledit)" -accelerator Ctrl+c
    .tmenu add command -label "Paste" -underline 0 -command "tk_textPaste $gui(sqledit)" -accelerator Ctrl+v
    .tmenu add command -label "Delete" -underline 2 -command "deletetext" -accelerator Del
    .tmenu add separator
    .tmenu add command -label "Select All" -underline 7 -command "$gui(sqledit) tag add sel 1.0 end" -accelerator Ctrl+/
    .tmenu add separator
    set mnu(tables) [menu .tmenu.tables -tearoff 0]
    .tmenu add cascade  -label "tables" -underline 0 -menu $mnu(tables)
    
    foreach table [lsort $tables] {
        regsub -all {\.} $table "-" mtable
        regsub -all { } $mtable "" mtable
        regsub -all {["']} $mtable "" mtable ;#"
        set mtable [string tolower $mtable]
        set mnu($table) [menu .tmenu.$mtable -tearoff 0]
        $mnu(tables) add cascade -label $table -menu $mnu($table) 
        if [regexp $table " "] {
            $mnu($table) add command -label $table -command "$gui(sqledit) insert insert \"$table\""
        } else {
            $mnu($table) add command -label $table -command "$gui(sqledit) insert insert $table"
        }
       $mnu($table) add separator
       #.tmenu add cascade -label "$table"  -command "puts $table"
       regsub -all " " $table "" otable
       regsub -all {["']} $otable "" otable ;#"
       set columns $var(tab-cols-$otable)
       regsub -all {,} $columns " " columns
       foreach col [lsort [split $columns]] {
           $mnu($table) add command -label $col -command "$gui(sqledit) insert insert $col"
       }
   }
   set mnu(sql) [menu .tmenu.state -tearoff 0]
   .tmenu add cascade  -label "SQL ..." -underline 0 -menu $mnu(sql)
   $mnu(sql) add command -label "SELECT ..." -underline 0 -command "$gui(sqledit) insert insert {SELECT col FROM table WHERE }"
   $mnu(sql) add command -label "VIEW ..." -underline 0 -command "$gui(sqledit) insert insert {CREATE VIEW view as SELECT col as col FROM table WHERE }"
   $mnu(sql) add  separator
   $mnu(sql) add command -label "INSERT ..."  -underline 0 -command "$gui(sqledit) insert insert {INSERT INTO table VALUES (...)}"
   $mnu(sql) add command -label "UPDATE ..."  -underline 0 -command "$gui(sqledit) insert insert {UPDATE table SET col = 'val' WHERE col = 'val'}"
   $mnu(sql) add  separator
   $mnu(sql) add command -label "DROP TABLE" -underline 0 -command "$gui(sqledit) insert insert {DROP TABLE }"
   $mnu(sql) add command -label "DROP VIEW" -underline 1 -command "$gui(sqledit) insert insert {DROP VIEW }"
  
}
proc Editor:FileLoad {w types} {
    set filename [tk_getOpenFile -filetypes $types]
    if {$filename != ""} {
        if [catch {open $filename r} infh] {
            tk_messageBox -title "Info!" -icon info -message "Could not load $filename !" -type ok
        } else {
            $w delete 1.0 end
            while {[gets $infh line] >= 0} {
                $w insert end "$line\n"
                
            }
            close $infh
        }
    }
}
proc Editor:FileSave {w types} {
    set savefile [tk_getSaveFile -filetypes $types]
    if {$savefile != ""} {
        set out [open $savefile w 0600]
        puts $out [$w get 1.0 end]
        close $out
        
    }
}
proc Schema:TextGetCols {tab} {
    set filename  "[lindex $tab 0]/schema.ini"
    if {[file exists  "$filename"]} {
        if [catch {open $filename r} infh] {
            puts stderr "Cannot open $filename: $infh"
            exit
        } else {
            set flag 0
            while {[gets $infh line] >= 0} {
                if {[string match "*?$tabelle?*" $line]} {
                    set flag 1
                    set cols {}
                } elseif {[string match {\[*} $line] && $flag == 1} {
                    break
                }
                       
                if {[regexp {Col[0-9]+=([^ ]+)} $line match col] && $flag == 1} {
                    lappend cols $col
                }
                
            }
            close $infh
            
        }
    }
    return $cols
}

proc Socket:Client {host port} {
    global var
    after 5000 {set var(connected) timeout}
    set socket [socket -async localhost 1025]
    tk_messageBox -title "Info!" -icon info -message "Client Debug here!" -type ok
    fileevent $socket w {set var(connected) ok}
 
    if {$var(connected) eq "timeout"} {
        return -code error timeout
    } else {
        tk_messageBox -title "Info!" -icon info -message "Client Debug2 here!" -type ok
        return $socket  
    }
}
proc Database:Client {} {
    global var gui
    set out [open "$var(serverfile)" w 0600]
    puts $out "db=$var(lastdb)"
    puts $out "[$gui(sqledit) get 1.0 end]"
    close $out
    set filename "sql.out.dat"
    sleep 5000
    while {1} {
        sleep 2000
        if {[file exists $filename]} {
            break
        }
    }
   
    if [catch {open $filename r} infh] {
        puts stderr "Cannot open $filename: $infh"
        exit
    } else {
        $gui(table) delete 0 end
        set max $var(max)
        incr max $var(offset)
        set offset $var(offset)
        set x 0
        while {[gets $infh line] >= 0} {
            if {$x == 0} {
                set cols [split $line "\t"]
                Tablelist:Colconf $gui(table) $cols
            } else {
                SQL:StatementGUI $x $max $offset
                set y 1
                foreach c [split $line "\t"] {
                    $gui(table) cellconfigure end,$y -text $c
                }
                incr y
            }
            incr x
        }
        close $infh
    }
}
proc Database:Server {} {
    global var
    if [catch {open "$var(serverfile)" r} infh] {
        puts stderr "Cannot open $filename: $infh"
        return
    } else {
        while {[gets $infh line] >= 0} {
            if {[regexp {db=(.+)} $line match database]} {
                continue
            }
            append statement $line
            
        }
        close $infh
    }
    if {[regexp -nocase {^\s*select +(.+) +from +'?([^ ]+?)'?} $statement matchvar columns table]} {
        if {$columns ne "*"} {
            regsub -all {[^ ]+ as +} $columns "" columns
            regsub -all " " $columns "" columns
            regsub -all "'" $columns "" columns
            set cols [split $columns ","]
        }  else {
            regsub -all " " $table "" table
            regsub -all {["']} $table "" table ;#"
            set cols $var(tab-cols-$table)
        }
    }
    regsub -all {\s+} $statement " " statement
    database connect db $database
    tk_messageBox -title "Info!" -icon info -message "executing $database $statement!" -type ok
    db statement s $statement
    s execute
    set out [open sql.out w 0600]
    set c $cols
    regsub -all " " $c "\t" c
    puts $out $c
  
    while {[s fetch row]} {
        set y 1
        foreach c $cols {
            set text $row($c)
            if {$text eq ""} {
                set text NULL
            }
            puts -nonewline $out "$text"
            if {$y < [llength $cols]} {
                puts -nonewline $out "\t"
            }
            incr y
            
        }
        puts $out ""
    }
    close $out
    file copy -force "sql.out" "sql.out.dat"
}

main
